<template lang="pug">
  div
    my-modal(
      @close="close"
      v-if="modal.type == 'lightBox'"
    )
      .lightboxContent(
        :style="{ 'background-image': 'url(' + modal.content.href+ ')' }"
      )
        img(
          :src="modal.content.href"
        )
      my-button(
        v-if="modal.content.prev"
        @click="prev"
      ) ＜ 前へ
      my-button(
        @click="close"
      ) 閉じる
      my-button(
        v-if="modal.content.next"
        @click="next"
      ) 次へ ＞
    p(style="margin: 20px 0") userName {{userName}}
    my-button(
      type="primary"
      size="small"
      @click="push('/shower')"
    ) シャワー画面へ
    .preview(v-if="uploader.input.blob")
      img( :src="uploader.input.blob" width="200")
      button.close(icon="close" @click="reset") ×
    input(
      id="file"
      type="file"
      accept="image/*"
      style="display:none"
      name="file"
      ref="fileInput"
      @change="selected"
    )
    div(style="margin: 20px 0")
      my-button(
        type="secondry"
        for="file"
        @click="triggerSelect"
        v-if="!uploader.input.blob") 写真を選ぶ
      my-button(
        for="file"
        @click="triggerSelect"
        v-else) 他の写真を選ぶ
      my-button(
        type="secondry"
        @click="submit"
        v-if="uploader.input.file"
      )
        span 画像を送信
    p.error(v-if="uploader.error" style="color-red") {{uploader.error}} 
    my-photo-table(
      :photos="photos"
      :meta="true"
      :openLightBox="openLightBox"
      @toggleActive="toggleItemActive({ name: $event.name, checked: $event.checked })"
      @pushPickUp="pushPickup($event)"
      @unshiftPickup="unshiftPickup($event)"
    )
</template>
<script>
import Router from 'vue-router'
import { mapActions, mapGetters } from 'vuex'
import MyButton from '@/components/atoms/Button'
import MyPhotoTable from '@/components/organisms/PhotoTable'
import MyPhotoShower from '@/components/organisms/PhotoShower'
import MyModal from '@/components/organisms/Modal'

import router from '@/router/index'

export default {
  name: 'Admin',
  components: {
    MyButton,
    MyPhotoTable,
    MyPhotoShower,
    MyModal
  },
  props: {
    // store
  },
  data() {
    return {
      photoIds: []
    }
  },
  computed: {
    ...mapGetters('Auth', {
      userName: 'userName',
      isApproved: 'isApproved',
      userId: 'userId'
    }),
    ...mapGetters('Top', {
      modal: 'modal'
    }),
    ...mapGetters('Photos', {
      photos: 'getPhotos',
      uploader: 'getUploader'
    })
  },
  created() {
    this.listen()
    this.listenPicker()
  },
  methods: {
    ...mapActions('Top', {
      close: 'close',
      openLightBox: 'openLightBox',
      changeLightBox: 'changeLightBox'
    }),
    ...mapActions('Photos', {
      // listenOnce: 'listenOnce', // adminでは常にlistenするのでonce不要
      listen: 'listen',
      listenPicker: 'listenPicker',
      upload: 'upload',
      onChangeFile: 'onChangeFile',
      toggleItemActive: 'toggleItemActive',
      pushPickup: 'pushPickup',
      unshiftPickup: 'unshiftPickup'
    }),
    push(path){
      router.push(path)
    },
    triggerSelect() {
      this.$refs.fileInput.click()
    },
    reset() {
      this.onChangeFile({ type: 'reset' })
    },
    selected(e) {
      const input = {}
      const file = (input.file = e.target.files[0])
      console.log(file)
      EXIF.getData(file, () => {
        input.orientation = file.exifdata.Orientation
      })
      if (!file) {
        input.blob = ''
      }
      if (!file.type.match('image.*')) {
        return
      }
      const reader = new FileReader()
      reader.readAsDataURL(file)
      reader.onload = () => {
        input.blob = reader.result
        this.onChangeFile(input)
      }
    },
    submit() {
      const input = this.uploader.input
      const userdata = {
        userId: this.userId,
        userName: this.userName
      }
      const name = file.name
      this.upload({ name, input, userdata })
    },
    next() {
      const index = Number(this.modal.content.index) + 1
      const path = this.modal.content.next
      this.changeLightBox({ index, path })
    },
    prev() {
      const index = Number(this.modal.content.index) - 1
      const path = this.modal.content.prev
      this.changeLightBox({ index, path })
    }
  }
}
</script>
<style lang="stylus">
.preview
  display: inline-block
  position: relative
  .close
    position: absolute
    top: 5px
    right: 5px
</style>
